###small simulation study:
####################################################
##n:sample size#####################################
##B:Monte Carlo size################################
##index:1 for MCAR, 2 for MAR and 3 for NMAR########
####################################################

fMC<-function(n,B,index){

Etheta1<-NULL
Etheta2<-NULL
Etheta3<-NULL
iter<-0
repeat{
iter<-iter+1
X<-rnorm(n)
epsilon<-rnorm(n)
Y<-1+X+epsilon
if(index==1){
P<-0.6
}
else if(index==2){
P<-exp(0.5+X)/(1+exp(0.5+X))
}
else if(index==3){
P<-exp(-0.4+X+Y)/(1+exp(-0.4+X+Y))
}
R<-rbinom(n,1,P)
XR<-X[R==1]
YR<-Y[R==1]
XM<-X[R==0]
etheta1<-mean(Y)
etheta2<-mean(Y[R==1])
l<-lm(YR~XR)
ebeta<-l$coefficients
eYM<-ebeta[1]+ebeta[2]*XM
etheta3<-(sum(YR)+sum(eYM))/n
Etheta1<-c(Etheta1,etheta1)
Etheta2<-c(Etheta2,etheta2)
Etheta3<-c(Etheta3,etheta3)
if(iter==B){break}
}

Etheta<-rbind(Etheta1,Etheta2,Etheta3)
Theta0<-rep(1,3)
bias<-apply(Etheta,1,mean)-Theta0
v<-apply(Etheta,1,var)
se<-sqrt(v)
rmse<-sqrt(bias^{2}+v)
RES<-cbind(bias,se,rmse)
RES<-round(RES,4)
rownames(RES)<-c('COM','RES','IMP')
return(RES)

}

RES_200_1000_1<-fMC(200,1000,1)
RES_200_1000_2<-fMC(200,1000,2)
RES_200_1000_3<-fMC(200,1000,3)

RES_200_1000<-rbind(RES_200_1000_1,RES_200_1000_2,RES_200_1000_3)
write.csv(RES_200_1000,file='R:/teaching/short course/missing data/session1/table1.csv')